=== debian/changelog ===
mysql-workbench (8.0.17+dfsg-1ubuntu2) eoan; urgency=medium

  [ Lars Tangvald ]
  * d/patches: Fix for building with MySQL
    - Disabled Werror compilation flag
      Upstream uses the flag to catch new warnings, but it will tend to
      cause build failures.

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 27 Sep 2019 15:42:05 +0100

mysql-workbench (8.0.17+dfsg-1ubuntu1) eoan; urgency=medium

  * d/patches: Fix for building with MySQL
    - Disabled all MariaDB-specific patches
    - Disabled new gcc 9.1 warnings pending upstream fix

 -- Lars Tangvald <lars.tangvald@oracle.com>  Fri, 16 Aug 2019 08:46:51 +0200

mysql-workbench (8.0.17+dfsg-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream release.
  * Fixed:
    + CVE-2018-2598 (Closes: #904112).
    + gnome-keyring --> libsecret (Closes: #867943, #769393).
    + FTBFS (Closes: #910052, #914761).
      Thanks, Andrius Merkys.
    + "Alter table crashes Workbench" (Closes: #871775).
    + "Cannot satisfy the gdal-abi-2-3-0 dependency" (Closes: #923729).
  * New patch to fix FTBFS on x86_32.
  * Standards-Version: 4.4.0.
  * debhelper & compat to version 12
  * Build-Depends:
    - libgnome-keyring-dev
    + libsecret-1-dev
    - antlr3
    + antlr4 (>= 4.6~)
    + libssh-dev (>= 0.8.1~)
    + default-jre-headless
    + libantlr4-runtime-dev

  [ Andrius Merkys ]
  * antlr-runtime is no longer present in upstream tarball.
  * Ceasing to exclude files under ext/scintilla/win32 as they seem to be
    required for CMake.
  * Fixing d/watch to exclude terminal '.' from extracted upstream version.
  * Extending patch mariadb-build.patch to cover WB_BOOL definition and
    handle MAX_NO_FIELD_TYPES enum value.
  * MariaDB now supports MYSQL_TYPE_JSON.
  * d/mysql-workbench-data.docs: README was renamed to README.md by upstream.
  * d/control: adding b-dep on "libantlr4-runtime-dev".
  * Improved descriptions in d/control.
  * Removing unused lintian override d/mysql-workbench-data.lintian-overrides.
  * Adding d/s/lintian-overrides to ignore 'duplicate word' warning.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 03 Aug 2019 13:22:16 +1000
