=== debian/control ===
Source: mysql-workbench
Section: database
Priority: optional
Standards-Version: 4.4.0
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
Build-Depends: debhelper (>= 12~) ,dh-python
    ,g++-8
 ,cmake ,perl
 ,autoconf ,automake ,libtool
 ,bison ,flex ,swig
 ,doxygen
 ,gettext
 ,antlr4 (>= 4.6~)
 ,libantlr4-runtime-dev
 ,libboost-dev
 ,libcairo2-dev
 ,libctemplate-dev
 ,libfreetype6-dev
 ,libgdal-dev
 ,libgl1-mesa-dev
 ,libglib2.0-dev
# ,libgnome-keyring-dev
    ,libsecret-1-dev
    ,libssh-dev (>= 0.8.1~)
###    ,libssh2-1-dev (>= 1.8.0~)
    ,default-jre-headless
 ,libgtk-3-dev
 ,libgtkmm-3.0-dev
 ,liblua5.1-0-dev
 ,libmysqlcppconn-dev (>= 1.1.12~)
 ,libpng-dev
 ,default-libmysqlclient-dev
 ,libpcre3-dev
 ,libpixman-1-dev
 ,libsqlite3-dev
 ,libtinyxml-dev (>= 2.6.2)
 ,libvsqlitepp-dev
 ,libxml2-dev
 ,libzip-dev
 ,python-dev
 ,python-paramiko
 ,unixodbc-dev
 ,uuid-dev
 ,xdg-utils
Homepage: http://dev.mysql.com/workbench/
Vcs-Browser: https://salsa.debian.org/debian/mysql-workbench
Vcs-Git: https://salsa.debian.org/debian/mysql-workbench.git

Package: mysql-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 ,mysql-workbench-data (= ${source:Version})
 ,python-mysql.connector
 ,python-paramiko
 ,python-pexpect
 ,python-pyodbc (>= 2.1.8)
 ,python-pysqlite2
Recommends: ttf-bitstream-vera, mysql-utilities
           ,default-mysql-client | virtual-mysql-client
#Suggests: gnome-keyring
Description: MySQL Workbench - a visual database modeling, administration and queuing tool
 MySQL Workbench is a modeling tool that allows one to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.

Package: mysql-workbench-data
Architecture: all
Depends: ${misc:Depends}
Description: MySQL Workbench -- architecture independent data
 MySQL Workbench is a modeling tool that allows one to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.
 .
 This package provides architecture independent files

#Package: mysql-workbench-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: MySQL Workbench -- Documentation for developers
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides documentation for developers
