=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
repacksuffix=+dfsg,\
repack,compression=xz,\
pgpsigurlmangle=s{$}{.asc},\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\.?\-rc}{~rc},\
" https://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools\
  /mysql-workbench-community-([\d\.]+)(?:\-rc\d*)?(?:-nodocs)?-src\.tar\.(?:gz|bz2|xz)
